function lines_str(str)
  local t = {}
  local function helper(line) table.insert(t, line) return "" end
  helper((str:gsub("(.-)\r?\n", helper)))
  return t
end
function extractzipwithinfo(string_zip, string_dest)
	Screen.disable3D()
	System.createDirectory(string_dest)
	ziphandle = System.openZIP(string_zip)
	filetable = lines_str(System.listFromZIP(ziphandle))
	for i = 1, #filetable, 1 do
		if (string.sub(filetable[i], -1) == "/") then
			Screen.waitVblankStart()
			Screen.refresh()
			Screen.clear(BOTTOM_SCREEN)
			Graphics.initBlend(BOTTOM_SCREEN)
			Graphics.drawImage(0, 0, submen0)
			Graphics.termBlend()
			Font_center(font, "Downloading "..update_ver..": Done!",Color.new(255,255,255), BOTTOM_SCREEN, nil, 10)
			Font_center(font, "Installing "..update_ver..": "..math.modf((i/#filetable) * 100).."%",Color.new(255,0,0), BOTTOM_SCREEN, nil, 50)
			Screen.flip()
			System.createDirectory(string_dest..filetable[i])
		else
			Screen.waitVblankStart()
			Screen.refresh()
			Screen.clear(BOTTOM_SCREEN)
			Graphics.initBlend(BOTTOM_SCREEN)
			Graphics.drawImage(0, 0, submen0)
			Graphics.termBlend()
			Font_center(font, "Downloading "..update_ver..": Done!",Color.new(255,255,255), BOTTOM_SCREEN, nil, 10)
			Font_center(font, "Installing "..update_ver..": "..math.modf((i/#filetable) * 100).."%",Color.new(255,0,0), BOTTOM_SCREEN, nil, 50)
			Screen.flip()
			System.deleteFile(string_dest..filetable[i])
			System.extractFromZIP(ziphandle,filetable[i],string_dest..filetable[i])
		end
	end
	System.closeZIP(ziphandle)
	ziphandle = nil
end
function startupdate(update_old)
	update_ver = array_ver[update_old]
	--Screen Draw
	Screen.waitVblankStart()
	Screen.refresh()
	Font.setPixelSizes(font, 24)
	Graphics.initBlend(BOTTOM_SCREEN)
	Graphics.drawImage(0, 0, submen0)
	Graphics.termBlend()
	Font_center(font, "Downloading "..update_ver.."...",Color.new(255,0,0), BOTTOM_SCREEN, nil, 10)
	Font_center(font, "Installing "..update_ver.."...",Color.new(255,255,255), BOTTOM_SCREEN, nil, 50)
	Screen.flip()
	--Download zip.
	if not Network.isWifiEnabled() then
		doexitapp()
	end
	DeleteDir(System.currentDirectory().."updates")
	System.createDirectory(System.currentDirectory().."updates")
	socket_download("www.dshack.org", "www.dshack.org", 443, "/assets/store/164/updatedatav"..update_ver..".zip", 32768, MAX_RAM_ALLOCATION, 10000, System.currentDirectory().."updates/"..update_ver..".zip", true, "update")
	Font.setPixelSizes(font, 24)
	if not System.doesFileExist(System.currentDirectory().."updates/"..update_ver..".zip") then
		doexitapp()
	end
	--Screen Draw
	Screen.waitVblankStart()
	Screen.refresh()
	Screen.clear(BOTTOM_SCREEN)
	Graphics.initBlend(BOTTOM_SCREEN)
	Graphics.drawImage(0, 0, submen0)
	Graphics.termBlend()
	Font_center(font, "Downloading "..update_ver..": Done!",Color.new(255,255,255), BOTTOM_SCREEN, nil, 10)
	Font_center(font, "Installing "..update_ver.."...",Color.new(255,0,0), BOTTOM_SCREEN, nil, 50)
	Screen.flip()
	--Extract zip
	extractzipwithinfo(System.currentDirectory().."updates/"..update_ver..".zip",System.currentDirectory())
	--Exit app
	Screen.waitVblankStart()
	Screen.refresh()
	Screen.clear(BOTTOM_SCREEN)
	Graphics.initBlend(BOTTOM_SCREEN)
	Graphics.drawImage(0, 0, submen0)
	Graphics.termBlend()
	Font_center(font, "Downloading "..update_ver..": Done!",Color.new(255,255,255), BOTTOM_SCREEN, nil, 10)
	Font_center(font, "Installing "..update_ver..": Done!",Color.new(255,255,255), BOTTOM_SCREEN, nil, 50)
	Screen.flip()
	DeleteDir(System.currentDirectory().."updates")
	Screen.waitVblankStart()
	Screen.refresh()
	Screen.clear(TOP_SCREEN)
	Screen.clear(BOTTOM_SCREEN)
	Screen.flip()
	Screen.waitVblankStart()
	Screen.refresh()
	Screen.clear(TOP_SCREEN)
	Screen.clear(BOTTOM_SCREEN)
	Screen.flip()
	tmptmr = Timer.new()
	while (Timer.getTime(tmptmr) < 1000) do end
	Timer.destroy(tmptmr)
	dofile(System.currentDirectory().."script.lua")
end